routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::get('test/{plant_id}', 'TestController@faseCalc');
Route::get('allPhaseCalc/', 'TestController@allPhaseCalc');



Auth::routes();

Route::get('/', 'HomeController@home')->name('home');
Route::get('/us', 'HomeController@us');


//feed
Route::group(['prefix' => 'feed','middleware' => 'auth'], function()
{
	Route::get('/{feed_id}/edit', 'FeedController@edit');

	Route::post('/text-update', 'FeedController@textUpdate');
	Route::post('/image-add', 'FeedController@imageAdd');
	Route::post('/image-delete', 'FeedController@imageDelete');
	Route::post('/delete', 'FeedController@delete');
	Route::post('/create', 'FeedController@create');
	Route::post('/comment', 'FeedController@comment');

});

//plant
Route::group(['prefix' => 'plant'], function()
{
			
	Route::get('/{plantId}', 'PlantController@show');
	Route::get('/{plantId}/images', 'PlantController@images');

	Route::group(['middleware' => 'auth'], function()
	{
		Route::get('/{plantId}/edit', 'PlantController@editView');

		Route::post('/create', 'PlantController@store');
		Route::post('/edit', 'PlantController@edit');
		Route::post('/phase-change', 'PlantController@phaseChange');
		Route::post('/harvest', 'PlantController@harvest');

	});	
});

//user
	Route::group(['prefix' => 'user'], function()
	{
		Route::get('/invitation', 'UserController@invitation');		
		Route::get('/{userId}', 'UserController@show');
		Route::get('/{userId}/plants', 'UserController@plants');
		Route::get('/{userId}/password/default', 'UserController@passwordDefault');

		Route::post('/invite', 'UserController@mailInvitation');
		Route::post('/update', 'UserController@config');

	});


	Route::group(['prefix' => 'strain'], function()
	{	
		Route::get('/', 'StrainController@index');	
		Route::get('/{strain_id}', 'StrainController@show');
		Route::get('/{strain_id}/plants', 'StrainController@plants');

		//ASIGNAR VARIEDAD A PLANTA
		Route::post('/getcr', 'StrainController@getCR');
		Route::post('/getdb', 'StrainController@getDB');
		Route::post('/assign-plant', 'StrainController@assignPlant');		
	});

app/Plant.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use App\Phase;
use Carbon\Carbon;

class Plant extends Model
{
    use SoftDeletes;
 	protected $table = 'plants';
    //proxima phase
    protected $appends = array('next_phase');

    public function strain()
    {
        return $this->belongsTo('App\Strain');
    }

    public function user()
    {
        return $this->belongsTo('App\User');
    }

    public function phase()
    {
        return $this->belongsTo('App\Phase');
    }

    public function posts()
    {
        return $this->hasMany('App\Post');
    }


    public function comments()
    {
        return $this->hasMany('App\Post')->where('type_id',5);
    }

    public function images()
    {
        return $this->hasMany('App\Post')->where('type_id',3);
    }

    public function Phases()
    {
        return $this->hasMany('App\Post')->where('type_id',4);
    }

    public function PhaseById($phase_id)
    {
        return $this->belongsTo('App\Post','plant_id')->where('type_id',4)->where('phase_id',$phase_id);
    }

    public function getPhaseAtAttribute($value)
    {
        if($value!=null)
        {
            return Carbon::createFromFormat('Y-m-d', $value);
        }
        else
        {
            return null;
        }

    }

    public function getNextPhaseAttribute($value) 
    {
        $plantPhaseId = $this->phase_id;
        if($plantPhaseId == 1)
            {
                $nextPhaseId = $plantPhaseId + 2; 
                $nextPhase = Phase::find($nextPhaseId);
                return $nextPhase;  
            }
        elseif($plantPhaseId >= 4)
            {

                return null;  
            }
        else
            {
                $nextPhaseId = $plantPhaseId + 1; 
                $nextPhase = Phase::find($nextPhaseId);
                return $nextPhase;
            }  


    }
}

app/Strain.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;


class Strain extends Model
{
	use SoftDeletes;
    protected $table = 'strains';
	
    public function bank()
    {
        return $this->belongsTo('App\Bank');
    }

    public function plants()
    {
        return $this->hasMany('App\Plant');
    }

    public function allplants()
    {
        return $this->hasMany('App\Plant')->withTrashed()->orderBy('created_at','desc');
    }

    public function feeds()
    {
        return $this->hasMany('App\Feed');
    }

    public function posts()
    {
        return $this->hasMany('App\Post');
    }

    public function comments()
    {
        return $this->hasMany('App\Post')->where('type_id',5);
    }

    public function images()
    {
        return $this->hasMany('App\Post')->where('type_id',3);
    }   


}

app/Http/Controllers/StrainController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Strain;
use GuzzleHttp\Exception\GuzzleException;
use GuzzleHttp\Client;
use App\Bank;
use App\Plant;
use Redirect;
use Session;

class StrainController extends Controller
{
	public function index()
	{
		$strains = Strain::all();

		return view('strain.index')->with('strains', $strains);
	}

	public function show($strain_id)
	{
		$strain = Strain::find($strain_id);
		$feeds = $strain->feeds()->simplePaginate(16);
		return view('strain.show')->with('strain', $strain)->with('feeds', $feeds);
	}

	public function plants($strain_id)
	{
		$strain = Strain::find($strain_id);
		return view('strain.plants')->with('strain', $strain);
	}
	public function getCR(Request $request)
	{
		$client = new Client();
		$ucpc = $request->ucpc;


		$res =  $client->request('GET', 'https://www.cannabisreports.com/api/v1.0/strains/'.$ucpc, ['exceptions' => false]);  
		if($res->getStatusCode()!=200)
		{
			Session::flash('warning', 'No se encuentra el codigo UCPC!'); 
			return Redirect::back();
		}

		$plant = Plant::withTrashed()->findOrFail($request->plant_id);
		
		$body = json_decode($res->getBody(), true);
		$strain_CR = $body['data'];
		$bank = $strain_CR['seedCompany'];

		//verificamos los bancos
		$bank_exist = Bank::where('ucpc',$bank['ucpc'])->first();
		if($bank_exist==null)
		{
			//no existe el banko
			$strain_bank = new Bank;
			$strain_bank->name = $bank['name'];
			$strain_bank->ucpc = $bank['ucpc'];
			$strain_bank->save();

		}
		else
		{
			$strain_bank = $bank_exist;
			
		}

		//verificamos las variedades
		$strain_exist = Strain::where('ucpc',$strain_CR['ucpc'])->first();
		if($strain_exist==null)
		{
			//no existe el banko
			$strain = new Strain;
			$strain->name = $strain_CR['name'];
			$strain->ucpc = $strain_CR['ucpc'];
			$strain->bank_id = $strain_bank->id;
			$strain->type = "nn";
			$strain->save();

		}
		else
		{
			$strain = $strain_exist;
			echo('existe variedad');
		}

		return view('plant.strain-select')->with('strain', $strain)->with('plant',$plant);


		
	}
	public function getDB(Request $request)
	{
		$plant = Plant::withTrashed()->findOrFail($request->plant_id);


		if($request->strain!=0 )
		{
			$strain = Strain::find($request->strain);
			return view('plant.strain-select')->with('strain', $strain)->with('plant',$plant);
		}
		else
		{
			return Redirect::back();
		}

	}

	public function assignPlant(Request $request)
	{
		$plant = Plant::withTrashed()->findOrFail($request->plant_id);
		$strain = Strain::find($request->strain_id);
		$plant->strain_id = $request->strain_id;
		if($plant->save())
		{

                Session::flash('success', 'Variedad '.$strain->name.' asignada a planta '.$plant->name.' '); 
                return redirect('/plant/'.$plant->id); 
		}

	}

}

resources/views/strain/index.blade.php
@extends('layouts.app')

@section('content')
<div class="container">

            {{-- Success --}}
            @if(Session::has('success'))
                    <div class="alert alert-success">
                        <i class=" fa fa-check position-left"></i>  {{ Session::get('success') }}
                    </div>
            @endif
            {{-- END Success --}}
             {{-- Errores --}}
            @if($errors->any())
            <div class="row">
                <div class="alert alert-danger">
                    @foreach ($errors->all() as $error)
                        <span>{{ $error }}</span>
                    @endforeach
                    
                </div>
            </div>
            @endif

    <div class="row">
        <div class="col-xl-12 col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div  id="photo-page" >
                <div class="photo-album-wrapper">
                @foreach($strains as $strain)
                
                    <div class="photo-album-item-wrap col-4-width">
                                        <div class="photo-album-item" data-mh="album-item" style="height: 458px;">
                                            <div class="photo-item">
                                                <img @if($strain->images) src="{{Cloudder::show($strain->images->last()['value'], ["width" =>600, "height" =>600, "crop"=>"fill", "format"=>"jpg"])}}" @else src="{{url('/img/plant.png')}}"@endif alt="photo">
                                                <div class="overlay overlay-light"></div>

                                                   
                                                    
                                                

                                            </div>

                                            <div class="content">
                                                <span class="sub-title">{{$strain->name}}</span>
                                               

                                            </div>

                                        </div>
                    </div>
                
                @endforeach
                </div>
            </div>
        </div>
    </div>

</div>





@endsection

@section('scripts')

resources/views/strain/plants.blade.php
@extends('layouts.app')

@section('content')
<div class="container ">

            {{-- Success --}}
            @if(Session::has('success'))
                    <div class="alert alert-success">
                        <i class=" fa fa-check position-left"></i>  {{ Session::get('success') }}
                    </div>
            @endif
            {{-- END Success --}}
             {{-- Errores --}}
            @if($errors->any())
            <div class="row">
                <div class="alert alert-danger">
                    @foreach ($errors->all() as $error)
                        <span>{{ $error }}</span>
                    @endforeach
                    
                </div>
            </div>
            @endif

    <div class="row">
        <div class="col-xl-12 col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="ui-block" style="margin-top: 70px;">
                <div class="top-header">
                    
                    <div class="profile-section">
                        <div class="row">

                            <div class="col-lg-5  col-md-5 ">
                                <ul class="profile-menu">

                                </ul>
                            </div>
                            <div class="col-lg-5 offset-lg-2 col-md-5 offset-md-2">
                                <ul class="profile-menu">
                                    <li>
                                        <a href="{{url('/strain/'.$strain->id)}}">Seguimientos</a>
                                    </li>
                                    <li>
                                        <a href="{{url('/strain/'.$strain->id.'/plants')}}">Plantas</a>
                                    </li>
                                </ul>
                            </div>
                        </div>
                    </div>
                    <div class="top-header-author">
                        <a  class="author-thumb">
                            <img src="{{url('/img/plant.png')}}" alt="author" width=124 height=124>
                        </a>
                        <div class="author-content">
                            <a href="#" class="h4 author-name">{{$strain->name}}</a>
                            <div class="country">
                               @if($strain->bank_id!=null)<strong>{{$strain->bank->name}}</strong> @endif {{$strain->type}}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>


    </div>
</div>
<div class="container">
    <div class="row">
        <div class="col-xl-12 col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div  id="photo-page" >
                <div class="photo-album-wrapper">
                @foreach($strain->allPlants as $plant)
                
                    <div class="photo-album-item-wrap col-4-width">
                                        <div class="photo-album-item" data-mh="album-item" style="height: 458px;">
                                            <div class="photo-item">
                                                <img @if($plant->avatar!=null) src="{{Cloudder::show($plant->avatar, ["width" =>600, "height" =>600, "crop"=>"fill", "format"=>"jpg","secure" => true])}}" @else src="{{url('/img/plant.png')}}"@endif alt="photo">
                                                <div class="overlay overlay-light"></div>
                                                <a href="{{url('/plant/'.$plant->id)}}" class="post-add-icon">
                                                   
                                                    
                                                </a>
                                                <a href="{{url('/plant/'.$plant->id)}}"  class="full-block"></a>
                                            </div>

                                            <div class="content">
                                                <a href="{{url('/plant/'.$plant->id)}}"  class="title h5">{{$plant->name}}</a>
                                                <span class="sub-title"> @if($plant->strain_id!=null)<a href="#">{{$plant->strain->name}}</a> @if($plant->strain->bank_id!=null) del banco <a href="#">{{$plant->strain->bank->name}}</a> @endif @endif</span>
                                                <span>{{$plant->phase->name}} hase {{Carbon\Carbon::now()->diffInDays($plant->phase_at)}} dias</span>

                                            </div>

                                        </div>
                    </div>
                
                @endforeach
                </div>
            </div>
        </div>
    </div>
</div>

@endsection

@section('scripts')

resources/views/strain/show.blade.php
@extends('layouts.app')

@section('content')
<div class="container">


    <div class="row">

        <div class="col-xl-12 col-lg-12 col-md-12 col-sm-12 col-xs-12">
            @include('alerts.alert')

        </div>
        
        <div class="col-xl-12 col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="ui-block" style="margin-top: 70px;">
                <div class="top-header">
                    
                    <div class="profile-section">
                        <div class="row">

                            <div class="col-lg-5  col-md-5 ">
                                <ul class="profile-menu">

                                </ul>
                            </div>
                            <div class="col-lg-5 offset-lg-2 col-md-5 offset-md-2">
                                <ul class="profile-menu">
                                    <li>
                                        <a href="{{url('/strain/'.$strain->id)}}">Seguimientos</a>
                                    </li>
                                    <li>
                                        <a href="{{url('/strain/'.$strain->id.'/plants')}}">Plantas</a>
                                    </li>
                                </ul>
                            </div>
                        </div>
                    </div>


                    <div class="top-header-author">
                        <a  class="author-thumb">
                            <img  src="{{url('/img/plant.png')}}" alt="author" width=124 height=124>
                        </a>
                        <div class="author-content">
                            <a href="#" class="h4 author-name">{{$strain->name}}</a>
                            <div class="country">
                               @if($strain->bank_id!=null)<strong>{{$strain->bank->name}}</strong> @endif {{$strain->type}}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="clients-grid">
                <div class="row sorting-container" id="clients-grid-1" data-layout="masonry">

                @foreach($feeds as $feed)
                    @if($feed->feedtype_id == 1)
                    <!-- tracking-feed  -->
                    @include('feed.track', ['feed' => $feed, 'page'=>'strain'])
                    <!-- ... end tracking-feed  -->
                    <!-- comment-popup  -->

                    @include('popup.comment', ['feed' => $feed])
                    <!-- ... end comment-popup -->
                    @endif 

                    @if($feed->feedtype_id == 2)
                    <!-- tracking-feed  -->
                    @include('feed.share', ['feed' => $feed, 'page'=>'strain'])
                    <!-- ... end tracking-feed  -->
                    <!-- comment-popup  -->
                    @include('popup.comment', ['feed' => $feed])

                    <!-- ... end comment-popup -->
                    @endif


                @endforeach    



                </div>

            </div>
        </div>
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 align-center padding80">
                <a class="btn btn-primary text-center" href="{{$feeds->nextPageUrl()}}"> Cargar mas seguimientos</a>
        </div> 
    </div>

</div>

{{-- Modals --}}



@endsection

@section('scripts')

@endsection